{Enterprise Dynamics startup information}

if(StartingED, SoftStartED([]));


{Model information}

AddLayer([Main], 1, 1, 0);
AddLayer([Test], 1, 2, 1);


{Load required atoms}

int011;
int035([Sink], pDir([Atoms\Sink.atm]));
int035([Queue], pDir([Atoms\Queue.atm]));
int035([Source], pDir([Atoms\Source.atm]));
int035([Unpack], pDir([Atoms\Unpack.atm]));
int035([Assembler], pDir([Atoms\Assembler.atm]));
int035([MultiService], pDir([Atoms\MultiService.atm]));
int035([Data Recorder], pDir([Atoms\Data Recorder.atm]));
int035([Generic Monitor], pDir([Atoms\Generic Monitor.atm]));
int012;


{Preregister functions}

PreregisterFunction([DetentionPeriod], 2, 2);
PreregisterFunction([SetDetentionPeriod], 3, 3);
PreregisterFunction([RefDetentionPeriod], 0, 0);


{Atom: DetentionPeriod}

sets;
AtomByName([Data Recorder], Main);
if(not(AtomExists), Error([Cannot find mother atom 'Data Recorder'. Inheriting from BaseClass.]));
CreateAtom(a, s, [], 1, false);
Set(OnInit, [DataRecorder_Init(c)]);
int023([DetentionPeriod], 16512, 32);
DefineFunction([DetentionPeriod], [Basic], 2, 2, [cell(p(1),p(2),vtp(186516680))], [Returns the value of cell(e1, e2)], [No example], 1, [Table.atm]);
DefineFunction([SetDetentionPeriod], [Basic], 3, 3, [setcell(p(1),p(2),p(3),vtp(186516680))], [Sets cell(e1, e2) to value e3], [No example], 1, [Table.atm]);
DefineFunction([RefDetentionPeriod], [Basic], 0, 0, [vtp(186516680)], [An atom reference to the table with an alias], [RefDetentionPeriod], 1, [Table.atm]);
Set(Icon(a), 
	RegisterIcon(pDir([media\images\default.jpg]), [default.jpg]));
SetMaterial(
	RegisterMaterial([Default], 8421504, 8421504, 3289650, 0, 0.100000001490116, 0, false, false, 1, 0), 1, a);
Set(Version(a), 0);
SetTreeIcon(pDir([Media\Icons\DataRecorder.ico]));
SetChannels(1, 1);
SetChannelRanges(1, 255, 1, 1);
int001(114);
int013(1, 0, true, true, 0, 0, [], []);
SetLoc(60, 7, 0);
SetSize(8, 2, 1);
LockPosition(false);
LockSize(false);
DisableIconRotation(false);
SetProductCode([]);
CreateAttributes(3);
SetAttributeName(r(1), [CustomerNumber]);
SetAttributeName(r(2), [DetentionPeriod]);
SetAttributeName(r(3), [NumberOfProductsTobuy]);
SetTextAtt(1, [DetentionPeriod]);
SetAtt(2, 0);
SetAtt(3, 1);
SetAtt(4, 1);
SetAtt(5, 1);
SetAtt(6, 5);
SetAtt(7, 0);
SetTextAtt(8, [untitled]);
SetTextAtt(9, [Sheet1]);
SetAtt(10, 1);
SetAtt(11, 1);
SetExprAtt(12, [hr(1)]);
SetAtt(13, 1);
SetAtt(14, 1);
SetAtt(15, 3);
SetAtt(16, 1);
SetExprAtt(17, [{.1|1. measure for all atoms.}1]);
SetExprAtt(18, [0]);
SetExprAtt(19, [hr(9.5)]);
SetAtt(20, 0);
SetAtt(21, 0);
SetAtt(22, 0);
SetTextAtt(r(1), [{.~1|~string(label([CustomerNumber],i))~.}string(label([CustomerNumber],i))]);
SetTextAtt(r(2), [{.~1|~time - label([IncTime],i)~.}time - label([IncTime],i)]);
SetTextAtt(r(3), [{.~1|~label([NumberOfProductsToBuy],i)~.}label([NumberOfProductsToBuy],i)]);
int024;
SetTable(1, 3);
int015(0, 64, [ 
1
]);
int015(1, 102, [`CustomerNumber`
]);
int015(2, 108, [`DetentionPeriod`
]);
int015(3, 144, [`NumberOfProductsTobuy`
]);
SetStatus(0);
int018;


{Atom: CustomerArrival}

sets;
AtomByName([Source], Main);
if(not(AtomExists), Error([Cannot find mother atom 'Source'. Inheriting from BaseClass.]));
CreateAtom(a, Up(s), [], 1, false);
Set(OnInit, [do(
 Dim([CustomerNumber], vbValue, 0),
 Dim([ToManyCustomers], vbValue, 0)
 {Dim([valDecisionVariable], vbValue, 7)}
)
]);
int023([CustomerArrival], 7168771, 240);
Set(Icon(a), 
	RegisterIcon(pDir([Media\Images\atoms\source.bmp]), [source]));
AddModel3D(
	RegisterModel3D(Model3DDir([\source.wrl]), [source.wrl], 0, 0, 0, 1, 1, -1, -90, 0, 0), a);
AddModel3D(
	RegisterModel3D(Model3DDir([\source_Resized.wrl]), [Source_Resized.wrl], 0, 0, 0, 1, 1, -1, -90, 0, 0), a);
SetMaterial(
	RegisterMaterial([Default], 8421504, 8421504, 3289650, 0, 0.100000001490116, 0, false, false, 1, 0), 1, a);
Set(Version(a), 0);
SetTreeIcon(pDir([Media\Icons\Source.ico]));
SetChannels(1, 1);
SetChannelRanges(1, 1, 1, 255);
int001(115);
int013(1, 0, true, false, 0, 0, [], []);
SetLoc(2, 5, 0);
SetSize(6, 3, 2);
LockPosition(false);
LockSize(false);
DisableIconRotation(false);
SetProductCode([]);
CreateAttributes(1);
SetAttributeName(r(1), [CustomerNumber]);
SetExprAtt(1, [{.~1|~1~.}1]);
SetExprAtt(2, [if (time < hr(7),
 Poisson(6),
 Poisson(6)/2
)]);
SetExprAtt(3, [{.~1|~do(
 if(
  CustomerNumber = 0,
  CustomerNumber := 1,
  Inc(CustomerNumber)
 ),
 Label([NumberOfProductsToBuy], i) := poisson(10),
 Label([IncTime], i) := Time,
 Label([CustomerNumber], i) := CustomerNumber
)~.}do(
 if(
  CustomerNumber = 0,
  CustomerNumber := 1,
  Inc(CustomerNumber)
 ),
 Label([NumberOfProductsToBuy], i) := poisson(10),
 Label([IncTime], i) := Time,
 Label([CustomerNumber], i) := CustomerNumber
)]);
SetExprAtt(4, [{Trace(Concat([Customer ],string(Label([CustomerNumber],i)),[ chooses products: ],string(Label([NumberOfProductsToBuy],i))))}]);
SetExprAtt(5, [Poisson(6)]);
SetExprAtt(6, [{.~1|~if (
 time < hr(9),
 -1,
 0
)~.}if (
 time < hr(9),
 -1,
 0
)]);
SetAtt(7, 4);
int024;
Set(OnReset, [Do(
 If(
  Not(AtomExists(In(1, c))),
  Do(
   createAtomCopy(
    AtomByName([Product], Library),
    Up( c),
    [Product]
   ),
   Connect(0, Last(Up(c)), 1, c),
   SetLoc(xLoc(c) - 5, yLoc(c), 0, Last(Up(c)))
  )
 ),
 If(
  Or(
   MaxProducts > 0,
   MaxProducts = -1
  ),
  createEvent(FirstProduct, c, 1)
 ),
 {* Busy *}
 Status(c) := 2,
 CloseAllOc(c),
 Dim([CustomerNumber], vbValue, 0),
 Dim([ToManyCustomers], vbValue, 0)
 {Dim([valDecisionVariable], vbValue, 7)}
)
]);
SetStatus(2);
int018;


{Atom: WaitingForTrolley}

sets;
AtomByName([Queue], Main);
if(not(AtomExists), Error([Cannot find mother atom 'Queue'. Inheriting from BaseClass.]));
CreateAtom(a, Up(s), [], 1, false);
int023([WaitingForTrolley], 12615680, 240);
Set(Icon(a), 
	RegisterIcon(IconsDir([bmp\atoms\queue.bmp]), [queue]));
SetMaterial(
	RegisterMaterial([Default], 8421504, 8421504, 3289650, 0, 0.100000001490116, 0, false, false, 1, 0), 1, a);
Set(Version(a), 0);
SetTreeIcon(pDir([Media\Icons\Queue.ico]));
SetChannels(1, 2);
SetChannelRanges(1, 255, 1, 255);
int001(116);
int013(1, 0, true, false, 0, 0, [], []);
int013(2, 0, true, false, 0, 0, [], []);
SetLoc(9, 5, 0);
SetSize(7, 3, 0);
LockPosition(false);
LockSize(false);
DisableIconRotation(false);
SetProductCode([]);
CreateAttributes(1);
SetAttributeName(r(1), [ToManyCustomers]);
SetExprAtt(1, [{.~1|~if(
 ToManyCustomers = 2, 
 2, 
 1
)~.}if(
 ToManyCustomers = 2, 
 2, 
 1
)]);
SetAtt(2, 50);
SetExprAtt(3, [do(
 if(
  ToManyCustomers = 0,
  ToManyCustomers := 1
 ),
  
 if(
  And(ToManyCustomers = 2, Content(c) <= 21), 
  do(
   ToManyCustomers := 1,
   Trace([Situation is starting to relaxe. Customers are stopping to go to an other supermarket!])
  )
 ),
 
 if(
  Content(c) > 30, 
  do(
   ToManyCustomers := 2,
   Trace([To many customers are waiting for a trolley! Some are leaving for an other supermarket!])
  ),
  ToManyCustomers := 1
 )
)]);
SetExprAtt(4, [0]);
SetExprAtt(5, [{.content(c)|Fifo (First In First Out).}content(c)]);
SetAtt(6, 1);
SetExprAtt(7, [{.openallic(c)|Any inputchannel.}openallic(c)]);
SetAtt(8, 2);
SetAtt(r(1), 1);
int024;
SetStatus(13);
int018;


{Atom: CustomerLeaves}

sets;
AtomByName([Sink], Main);
if(not(AtomExists), Error([Cannot find mother atom 'Sink'. Inheriting from BaseClass.]));
CreateAtom(a, Up(s), [], 1, false);
int023([CustomerLeaves], 7168771, 240);
Set(Icon(a), 
	RegisterIcon(pDir([Media\Images\Atoms\sink.bmp]), [sink]));
AddModel3D(
	RegisterModel3D(Model3DDir([\sink.wrl]), [sink.wrl], 0, 0, 0, 1, 1, -1, -90, 0, 0), a);
AddModel3D(
	RegisterModel3D(Model3DDir([\sink_Resized.wrl]), [sink_Resized.wrl], 0, 0, 0, 1, 1, -1, -90, 0, 0), a);
SetMaterial(
	RegisterMaterial([Default], 8421504, 8421504, 3289650, 0, 0.100000001490116, 0, false, false, 1, 0), 1, a);
Set(Version(a), 0);
SetTreeIcon(pDir([Media\Icons\Sink.ico]));
SetChannels(1, 0);
SetChannelRanges(1, 255, 0, 0);
int001(117);
int013(1, 0, true, true, 0, 0, [], []);
SetLoc(24, 1, 0);
SetSize(5, 2, 2);
LockPosition(false);
LockSize(false);
DisableIconRotation(false);
SetProductCode([]);
SetExprAtt(1, [0]);
SetAtt(2, 4);
int024;
SetStatus(1);
int018;


{Atom: CustomerLeavesWithProducts}

sets;
AtomByName([Sink], Main);
if(not(AtomExists), Error([Cannot find mother atom 'Sink'. Inheriting from BaseClass.]));
CreateAtom(a, Up(s), [], 1, false);
int023([CustomerLeavesWithProducts], 7168771, 240);
Set(Icon(a), 
	RegisterIcon(pDir([Media\Images\Atoms\sink.bmp]), [sink]));
AddModel3D(
	RegisterModel3D(Model3DDir([\sink.wrl]), [sink.wrl], 0, 0, 0, 1, 1, -1, -90, 0, 0), a);
AddModel3D(
	RegisterModel3D(Model3DDir([\sink_Resized.wrl]), [sink_Resized.wrl], 0, 0, 0, 1, 1, -1, -90, 0, 0), a);
SetMaterial(
	RegisterMaterial([Default], 8421504, 8421504, 3289650, 0, 0.100000001490116, 0, false, false, 1, 0), 1, a);
Set(Version(a), 0);
SetTreeIcon(pDir([Media\Icons\Sink.ico]));
Set(DdbRec, [>mindetention:999.]);
SetChannels(1, 0);
SetChannelRanges(1, 255, 0, 0);
int001(118);
int013(1, 0, true, true, 0, 0, [], []);
SetLoc(69, 7, 0);
SetSize(6, 3, 2);
LockPosition(false);
LockSize(false);
DisableIconRotation(false);
SetProductCode([]);
SetExprAtt(1, [do(
 {Trace(Concat([Customer ], string(Label([CustomerNumber],i)), [ needed ], string(Time - Label([IncTime], i)), [ seconds for his purchase])),}
 
 {Calculating Min/Max and Avg-Values of Customers' detention period}
 do(
  Var([Val], vbValue, 0),
  Var([CurrentRow], vbValue, 1),
  Var([CurrentMin], vbValue, 999),
  Var([CurrentMax], vbValue, 0),
  Var([CurrentAvg], vbValue, 0),
  Var([Summe], vbValue, 0),
  Var([Rows], vbValue, nRows(RefDetentionPeriod)),

  if(
   Rows > 0,
   do(
    Repeat(
     Rows,
     do(
      Val := Cell(CurrentRow, 2, RefDetentionPeriod),
      if (
       And(Val <> 0, Val < CurrentMin),
       do (
        CurrentMin := Val,
        Label([MinDetention], c) := CurrentMin
       )
      ),
      if ( 
       Val > CurrentMax,
       do (
        CurrentMax := Val,
        Label([MaxDetention], c) := CurrentMax
       )
      ),
      Summe := Summe + Val,
      Inc(CurrentRow)
     )
    ),
    
    CurrentAvg := Summe / Rows,
    Label([AvgDetention], c) := CurrentAvg,
    if (
     Time > hr(9),
     Label([TimeTillLastCustomerLeaves], c) := Time - hr(9),
     Label([TimeTillLastCustomerLeaves], c) := 0
    )
    {Trace(Concat([Minimum: ], string(CurrentMin), [, Maximum: ], string(CurrentMax), [, Average: ], string(CurrentAvg), [, Time: ], string((Time-hr(9))/3600)))}   
   ),
   Trace([Rows = 0])
  )
 )
)]);
SetAtt(2, 4);
int024;
Set(OnReset, [do (
 Label([MinDetention], c) := 999,
 Label([MaxDetention], c) := 0,
 Label([AvgDetention], c) := 0,
 Label([TimeTillLastCustomerLeaves], c) := 0
)
]);
Set(On2DDraw, [do(
 StandardDisplay(Name, Concat([In: ], String(Input)), Icon),
 diText(xSize(c)+1, 0, Concat([Min Detention: ], string(Label([MinDetention], c))), ColorBlack, ColorWhite, 0.5, [Arial]),
 diText(xSize(c)+1, 1, Concat([Max Detention: ], string(Label([MaxDetention], c))), ColorBlack, ColorWhite, 0.5, [Arial]),
 diText(xSize(c)+1, 2, Concat([Avg Detention: ], string(Round(Label([AvgDetention], c),4))), ColorBlack, ColorWhite, 0.5, [Arial]),
 diText(xSize(c)+1, 3, Concat([Time till last Customer leaves: ], string(Label([TimeTillLastCustomerLeaves], c))), ColorBlack, ColorWhite, 0.5, [Arial])
)
]);
SetStatus(1);
int018;


{Atom: WaitingQueue}

sets;
AtomByName([Queue], Main);
if(not(AtomExists), Error([Cannot find mother atom 'Queue'. Inheriting from BaseClass.]));
CreateAtom(a, Up(s), [], 1, false);
int023([WaitingQueue], 12615680, 240);
Set(Icon(a), 
	RegisterIcon(IconsDir([bmp\atoms\queue.bmp]), [queue]));
SetMaterial(
	RegisterMaterial([Default], 8421504, 8421504, 3289650, 0, 0.100000001490116, 0, false, false, 1, 0), 1, a);
Set(Version(a), 0);
SetTreeIcon(pDir([Media\Icons\Queue.ico]));
SetChannels(1, 1);
SetChannelRanges(1, 255, 1, 255);
int001(119);
int013(1, 0, true, false, 0, 0, [], []);
SetLoc(35, 7, 0);
SetSize(6, 3, 0);
LockPosition(false);
LockSize(false);
DisableIconRotation(false);
SetProductCode([]);
SetExprAtt(1, [{.Min(NrOC(c), NrOC(c) + 1 - IndexMatch(NrOC(c), 1, OCReady(NrOC(c) + 1 - Count, c)))|2. An open channel (First channel first): search, starting from the first channel, and send to the first open channel found..}Min(NrOC(c), NrOC(c) + 1 - IndexMatch(NrOC(c), 1, OCReady(NrOC(c) + 1 - Count, c)))]);
SetAtt(2, 150);
SetExprAtt(3, [{Do(}
{  Case(}
{    { * Determine the content of the queue, i.e. the number of waiting customers * }
{    WhichIsTrue(}
{      Content(c) < valDecisionVariable,}
{      Content(c) < 2*valDecisionVariable,}
{      Content(c) < 3*valDecisionVariable,}
{      Content(c) < 4*valDecisionVariable,}
{      Content(c) < 5*valDecisionVariable,}
{      Content(c) < 6*valDecisionVariable,}
{      Content(c) < 7*valDecisionVariable,}
{      Content(c) < 8*valDecisionVariable,}
{      Content(c) < 9*valDecisionVariable,}
{      Content(c) < 10*valDecisionVariable,}
{      Content(c) < 11*valDecisionVariable,}
{      Content(c) < 12*valDecisionVariable,}
{      Content(c) < 13*valDecisionVariable,}
{      Content(c) < 14*valDecisionVariable,}
{      Content(c) < 15*valDecisionVariable,}
{      True}
{    ),}
{    { * Change the capacity of the cash-desk, based on the number of waiting customers * }
{    Att([Capacity], Out(1, c)) := 4,}
{    Att([Capacity], Out(1, c)) := 5,}
{    Att([Capacity], Out(1, c)) := 6,}
{    Att([Capacity], Out(1, c)) := 7,}
{    Att([Capacity], Out(1, c)) := 8,}
{    Att([Capacity], Out(1, c)) := 9,}
{    Att([Capacity], Out(1, c)) := 10,}
{    Att([Capacity], Out(1, c)) := 11,}
{    Att([Capacity], Out(1, c)) := 12,}
{    Att([Capacity], Out(1, c)) := 13,}
{    Att([Capacity], Out(1, c)) := 14,}
{    Att([Capacity], Out(1, c)) := 15,}
{    Att([Capacity], Out(1, c)) := 16,}
{    Att([Capacity], Out(1, c)) := 17,}
{    Att([Capacity], Out(1, c)) := 18}
{  ),}
{  }
{  { * In case there is space for another customer, open the input * }
{  CreateEvent(0, Out(1, c), 2)}
{)}]);
SetExprAtt(4, [0]);
SetExprAtt(5, [{.content(c)|Fifo (First In First Out).}content(c)]);
SetAtt(6, 1.88);
SetExprAtt(7, [{.openallic(c)|Any inputchannel.}openallic(c)]);
SetAtt(8, 2);
int024;
Set(OnEvent, [Case(
 EventCode,
 {** Event  1: Open the output channel **}
 OpenAllOc( c),
 {** Event 2: Input strategy **}
 InStrategy
)
]);
SetStatus(13);
int018;


{Atom: CustomerSelectsProducts}

sets;
AtomByName([MultiService], Main);
if(not(AtomExists), Error([Cannot find mother atom 'MultiService'. Inheriting from BaseClass.]));
CreateAtom(a, Up(s), [], 1, false);
int023([CustomerSelectsProducts], 0, 1256);
Set(Icon(a), 
	RegisterIcon(IconsDir([bmp\atoms\server.bmp]), [server]));
SetMaterial(
	RegisterMaterial([Default], 8421504, 8421504, 3289650, 0, 0.100000001490116, 0, false, false, 1, 0), 1, a);
Set(Version(a), 0);
SetTreeIcon(pDir([Media\Icons\MultiServer.ico]));
SetChannels(1, 1);
SetChannelRanges(1, 255, 1, 255);
int001(120);
int013(1, 0, true, false, 0, 0, [], []);
SetLoc(25, 7, 0);
SetSize(9, 4, 1);
LockPosition(false);
LockSize(false);
DisableIconRotation(false);
SetProductCode([]);
SetAtt(1, 70);
SetExprAtt(2, [Label([NumberOfProductsToBuy],i)*10]);
SetAtt(3, 0);
SetAtt(4, 0);
SetExprAtt(5, [{.IndexMin(NrOC(c), if(OCReady(Count,c), Content(out(Count,c)),1e50))|14: Smallest queue: Send to the channel connected to the atom with the smallest queue.}IndexMin(NrOC(c), if(OCReady(Count,c), Content(out(Count,c)),1e50))]);
SetExprAtt(6, [{.openallic(c)|Any inputchannel.}openallic(c)]);
SetExprAtt(7, [{Label([IncTime],i) := Time}]);
SetExprAtt(8, [{Trace(Concat([Time needed for customer ],string(Label([CustomerNumber],i)),[ to select products: ],string(Time-Label([IncTime],i))))}]);
SetAtt(9, 0);
SetAtt(10, 2);
SetAtt(11, 0);
int024;
SetStatus(1);
int018;


{Atom: Trolley}

sets;
BaseClass;
CreateAtom(a, Up(s), [], 1, false);
int023([Trolley], 12615680, 8273);
Set(Icon(a), 
	RegisterIcon(IconsDir([bmp\atoms\product.bmp]), [product]));
AddModel3D(
	RegisterModel3D(Model3DDir([\box-closed.wrl]), [box-closed.wrl], 0, 0, 0, 1, 1, -1, -90, 0, 0), a);
AddModel3D(
	RegisterModel3D(Model3DDir([\box-opened.wrl]), [box-opened.wrl], 0, 0, 0, 1, 1, -1, -90, 0, 0), a);
AddModel3D(
	RegisterModel3D(Model3DDir([\pallet-wood.wrl]), [pallet-wood.wrl], 0, 0, 0, 1, 1, -1, -90, 0, 0), a);
AddModel3D(
	RegisterModel3D(Model3DDir([\pallet-plastic.wrl]), [pallet-plastic.wrl], 0, 0, 0, 1, 1, -1, -90, 0, 0), a);
AddModel3D(
	RegisterModel3D(Model3DDir([\oildrum.wrl]), [oildrum.wrl], 0, 0, 0, 1, 1, -1, -90, 0, 0), a);
AddModel3D(
	RegisterModel3D(Model3DDir([\crate.wrl]), [crate.wrl], 0, 0, 0, 1, 1, -1, -90, 0, 0), a);
SetMaterial(
	RegisterMaterial([Default], 8421504, 8421504, 3289650, 0, 0.100000001490116, 0, false, false, 1, 0), 1, a);
Set(Version(a), 0);
SetTreeIcon(pDir([Media\Icons\Product.ico]));
Set(Info, [A general product.

General
-----------
Put a product in your model and connect it's central channel 
with the input channel of a source to generate multiple instances 
of the product during running.

Notes:
---------
For cylinder shaped, horizontally oriented 3D icons set ySize 
equal to zSize.
For cylinder shaped, vertically oriented 3D icons set xSize 
equal to ySize.
For sphere set xSize equal to ySize and zSize.

Last revision:
------------------
September 27, 2003
]);
Set(DdbRec, [>t-nodestroy:1.]);
int001(121);
SetLoc(0, 11, 0);
SetSize(1, 1, 1);
LockPosition(false);
LockSize(false);
DisableIconRotation(false);
SetProductCode([]);
CreateAttributes(2);
SetAttributeName(r(1), [Icon3D]);
SetAttributeName(r(2), [Hide2DIcon]);
SetAtt(r(1), 11);
SetAtt(r(2), 1);
int024;
Set(OnCreation, [{ In the OnInit event handler some edit fields are registered. }
{ This is ok for the product in the library tree, but not for the  }
{ products in the model, so erase the OnInit expression.       }
Set(OnInit, [])
]);
Set(OnReset, [If(
 Label( [t-nodestroy] , c) = 0,
 DestroyAtom
)
]);
Set(OnUser, [Do(
  { Delete any current instances of this form.} 
  GuiDestroy([Product]),

  { Register the GUI-form for this atom.}
  GuiRegister(PDir([\Atoms\Product.gui]), 1),

  { Show the GUI-form.}
   GuiCreate([Product], [Product], 0, c, 0, 1)
   )
]);
Set(On2DDraw, [if(
 c.DrawFlag,
 
 {--External atom(s) control product rotationas--}
 do(
  {--Variables for rotationas in order to compensate change of transportation direction--}
  RotateCoords(c.DrawRotationas, 0, 0, 1),
  
  {--Variables for translation in order to compensate change of transportation direction--}
  TranslateCoords(c.DrawXtranslate, c.DrawYtranslate, 0),
  
  {--Rotated shape--}
  dishape(0, 0 ,c.DrawXsize, c.DrawYsize, 0.01, ColorBlack, color(c))
 ),
 
 {--Standard--}
 do(
  c.DrawXsize := xSize(c),
  c.DrawYsize := ySize(c),
  diBmp(0, 0, Hide2DIcon * Icon(c), 1, 5)
 )
 
)
]);
Set(On3DDraw, [do(

 if(
  {--Product rotationas has been changed by external atom (e.g. Corner Transfer Unit)--}
  c.DrawFlag,
  do(
   {--Variables for rotationas in order to compensate change of transportation direction--}
   RotateCoords(c.DrawRotationas,0,0,1),
   
   {--Variables for translation in order to compensate change of transportation direction--}
   TranslateCoords(c.DrawXtranslate, c.DrawYtranslate,0)
  ),
  {--Standard--}
  do(
   c.DrawXsize := xSize(c),
   c.DrawYsize := ySize(c)
  )
 ),

 Case(
 Icon3D,
  {** Cube  **}
  di3DBox(0, 0, 0, c.DrawXsize, c.DrawYsize, zSize, Color),
  {**  Picture Cube **}
  di3DBox(0, 0, 0, c.DrawXsize, c.DrawYsize, zSize, Color, 0, 0, Icon, 0, 100, 100),
  {** Cylinder Horizontal **}
  Do(
   c.CenterPoint := Max(c.DrawYsize / 2, zSize / 2),
   Cylinder(0, c.CenterPoint, c.CenterPoint, c.DrawXsize, 360, c.CenterPoint, 0, 0, 0, Color)
  ),
  {** Cylinder Vertical **}
  Do(
   c.CenterPoint := Max(c.DrawXsize / 2, c.DrawYsize / 2),
   Cylinder(c.CenterPoint, c.CenterPoint, 0, zSize, 360, c.CenterPoint, 0, 90, 0, Color)
  ),
  {** Ball **}
  Do(
   c.CenterPoint := Max(c.DrawXsize / 2, Max(c.DrawYsize / 2, zSize / 2)),
   Ball( c.CenterPoint, c.CenterPoint, c.CenterPoint, c.CenterPoint, 180, 360, 0, 0, 0, Color)
  ),
  {** Cone **}
  Do(
   c.CenterPoint := Max(c.DrawXsize, c.DrawYsize),
   Cone(c.CenterPoint / 2, c.CenterPoint / 2, 0, zSize, c.CenterPoint / 2, 0, 0, 90, 0, Color)
  ),
  {** Barrel Horizontal **}
  Do(
   c.CenterPoint := Max(c.DrawYsize / 2, zSize / 2),
   Cylinder(0, c.CenterPoint, c.CenterPoint, c.DrawXsize, 360, c.CenterPoint, 0, 0, 0, Color),
   Cone(0, c.CenterPoint, c.CenterPoint, 0, c.CenterPoint, 0, 0, 0, 0, Color),
   Cone(c.DrawXsize, c.CenterPoint, c.CenterPoint, 0, c.CenterPoint, 0, 0, 0, 0, Color)
  ),
  {** Barrel Vertical **}
  Do(
   c.CenterPoint := Max(c.DrawXsize / 2, c.DrawYsize / 2),
   Cylinder(c.CenterPoint, c.CenterPoint, 0, zSize, 360, c.CenterPoint, 0, 90, 0, Color),
   Cone(c.CenterPoint, c.CenterPoint, zSize, 0, c.CenterPoint, 0, 0, 90, 0, Color),
   Cone(c.CenterPoint, c.CenterPoint, 0, 0, c.CenterPoint, 0, 0, 90, 0, Color)
  ),
  {** Pallet **}
  Do(
   di3DBox(0, 0, 0, c.DrawXsize, 0.1, zSize - 0.05, Color),
   di3DBox(0, /( c.DrawYsize, 2) - 0.05, 0, c.DrawXsize, 0.1, zSize - 0.05, Color),
   di3DBox(0, c.DrawYsize - 0.1, 0, c.DrawXsize, 0.1, zSize - 0.05, Color),
   c.CenterPoint := c.DrawXsize / 5,
   Repeat(
    5,
    di3DBox(Count * c.CenterPoint, 0, zSize - 0.05, -0.1, c.DrawYsize, 0.05, Color)
   )
  ),
  {** Simple Person **}
  Do(
   c.CenterPoint := c.DrawYsize / 2,
   {head} Ball( 0, c.CenterPoint, 1.8, 0.1, 180, 360, 0, -90 ,0, 7846395),
   {neck} Cylinder(0, c.CenterPoint, 1.65, 0.1, 360, 0.05, 0, 90, 0, 7846395),
   {shoulders}EllipseCone(0, c.CenterPoint, 1.52, 0.15, 360, 0.08, 0.05, 0.12, 0.2, 0, 90, 0, Color),
   {arm 1}  Cone(0, 0.15 + c.CenterPoint, 1.5, 0.5, 0.05, 0.02, 20, -80, 0, Color),
   {arm 2}  Cone(0, -0.15 + c.CenterPoint, 1.5, 0.5, 0.05, 0.02, 20, -80, 0, Color),
   {hand 1} Cone(0.08, -0.12 + c.CenterPoint, 1.02, 0.1, 0.02, 0.02, 20, -80, 0, 7846395),
   {hand 2}  Cone(0.08, 0.18 + c.CenterPoint, 1.02, 0.1, 0.02, 0.02, 20, -80, 0, 7846395),
   {body}  EllipseCone(0,c.CenterPoint, 1.07, 0.45, 360, 0.12, 0.2, 0.08, 0.1, 0, 90, 0, Color),
   {waist}  EllipseCone(0,c.CenterPoint, 0.92, 0.15, 360, 0.08, 0.1, 0.11, 0.15, 0, 90, 0, ColorGray),
   {leg 1}  Cone(0, 0.07 + c.CenterPoint, 0, 0.92, 0.03, 0.08, 0, 90, 0, ColorGray),
   {leg 2}  Cone(0, -0.07 + c.CenterPoint, 0, 0.92, 0.03, 0.08, 0, 90, 0, ColorGray),
   {foot 1}  EllipseCone(0, 0.07 + c.CenterPoint, 0,0.2, 180, 0.01, 0.03, 0.04, 0.05, 0, 0, 0, ColorBlack),
   {foot 2}  EllipseCone(0, -0.07 + c.CenterPoint, 0, 0.2, 180, 0.01, 0.03, 0.04, 0.05, 0, 0, 0, ColorBlack)
  ),
  {** Closed Carton Box **}
  DrawModel3D(Model3D(1, c), 0, 0, 0, c.DrawXsize, c.DrawYsize, zSize),
  {** Open Carton Box **}
  DrawModel3D(Model3D(2, c), 0, 0, 0, c.DrawXsize, c.DrawYsize, zSize),
  {** Pallet - Wood **}
  DrawModel3D(Model3D(3, c), 0, 0, 0, c.DrawXsize, c.DrawYsize, zSize),
  {** Pallet - Plastic **}
  DrawModel3D(Model3D(4, c), 0, 0, 0, c.DrawXsize, c.DrawYsize, zSize),
  {** Oildrum **}
  DrawModel3D(Model3D(5, c), 0, 0, 0, c.DrawXsize, c.DrawYsize, zSize),
  {** Crate **}
  DrawModel3D(Model3D(6, c), 0, 0, 0, c.DrawXsize, c.DrawYsize, zSize)
 )

)
]);
SetStatus(0);
int018;


{Atom: CustomersAreLeaving}

sets;
AtomByName([MultiService], Main);
if(not(AtomExists), Error([Cannot find mother atom 'MultiService'. Inheriting from BaseClass.]));
CreateAtom(a, Up(s), [], 1, false);
int023([CustomersAreLeaving], 0, 232);
Set(Icon(a), 
	RegisterIcon(IconsDir([bmp\atoms\server.bmp]), [server]));
SetMaterial(
	RegisterMaterial([Default], 8421504, 8421504, 3289650, 0, 0.100000001490116, 0, false, false, 1, 0), 1, a);
Set(Version(a), 0);
SetTreeIcon(pDir([Media\Icons\MultiServer.ico]));
SetChannels(1, 1);
SetChannelRanges(1, 255, 1, 255);
int001(122);
int013(1, 0, true, false, 0, 0, [], []);
SetLoc(15, 1, 0);
SetSize(8, 3, 1);
LockPosition(false);
LockSize(false);
DisableIconRotation(false);
SetProductCode([]);
SetAtt(1, 10);
SetExprAtt(2, [10]);
SetAtt(3, 0);
SetAtt(4, 0);
SetExprAtt(5, [{.~1|~1~.}1]);
SetExprAtt(6, [{.openallic(c)|Any inputchannel.}openallic(c)]);
SetExprAtt(7, [0]);
SetExprAtt(8, [0]);
SetAtt(9, 0);
SetAtt(10, 1);
SetAtt(11, 0);
int024;
SetStatus(1);
int018;


{Atom: Customer}

sets;
BaseClass;
CreateAtom(a, Up(s), [], 1, false);
Set(OnInit, [RegisterEditField(
 [t-container3dicon],
 [3D Icon],
 [Att([ContainerType])],
 [SetAtt([ContainerType], &)],
 FieldListBox(
  7,
  [Box/Transparant Box/Container/Pallet/Pallet with Stabilizers/Box with Texture/VR Icon]
 )
)
]);
int023([Customer], 6080220, 1234);
Set(Icon(a), 
	RegisterIcon(IconsDir([bmp\atoms\Pallet.bmp]), [Pallet.bmp]));
AddModel3D(
	RegisterModel3D(Model3DDir([\pallet-wood.wrl]), [pallet-wood.wrl], 0, 0, 0, 1, 1, -1, -90, 0, 0), a);
AddModel3D(
	RegisterModel3D(Model3DDir([\pallet-plastic.wrl]), [pallet-plastic.wrl], 0, 0, 0, 1, 1, -1, -90, 0, 0), a);
AddModel3D(
	RegisterModel3D(Model3DDir([\crate.wrl]), [crate.wrl], 0, 0, 0, 1, 1, -1, -90, 0, 0), a);
SetMaterial(
	RegisterMaterial([Default], 8421504, 8421504, 3289650, 0, 0.100000001490116, 0, false, false, 1, 0), 1, a);
Set(Version(a), 0);
SetTreeIcon(pDir([Media\Icons\Container.ico]));
Set(Info, [Container.

General
------------
Container for other atoms. Pack other atoms into this atom.

Right click parameters:
- several 3D icons like pallet, box and transparant box.
- triggers to manipulate atoms that enter/exit
- resize entering atoms to fit the container

Double click to edit content.

Last revision:
-------------------
September 29, 2003
]);
Set(DdbRec, [>centerpoint:0.22.>t-nodestroy:1.]);
int001(123);
SetLoc(0, 6, 0);
SetSize(1.1, 1.1, 0.15);
LockPosition(false);
LockSize(false);
DisableIconRotation(false);
SetProductCode([]);
CreateAttributes(6);
SetAttributeName(r(1), [AutoReSize]);
SetAttributeName(r(2), [sx]);
SetAttributeName(r(3), [sy]);
SetAttributeName(r(4), [sz]);
SetAttributeName(r(5), [ContainerType]);
SetAttributeName(r(6), [UseBoxVisible]);
SetExprAtt(r(2), [1.1]);
SetExprAtt(r(3), [1.1]);
SetExprAtt(r(4), [1]);
SetAtt(r(5), 4);
SetAtt(r(6), 1);
int024;
Set(OnEntered, [Do(
 If(
  AutoReSize,
  SetSize( sx, sy, sz, i)
 ),
 If(
  Content(c) = 1,
  SetLoc(
   Max( (sx - xSize( i)) / 2, 0),
   Max( (sy - ySize( i)) / 2, 0),
   zSize( c),
   i
  ),
  Do(
   SetLoc(
    xLoc( Prev( i)) + sx,
    yLoc( Prev( i)),
    zLoc( Prev( i)),
    i
   ),
   If(
    xLoc( i) >= xSize( c),
    Do(
     SetLoc( 
      xLoc( First( c)), 
      yLoc( i) + sy, 
      zLoc( i), 
      i
     ),
     If(
      yLoc( i) >= ySize( c),
      SetLoc(
       xLoc( First( c)),
       yLoc( First( c)),
       zLoc( i) + sz,
       i
      )
     )
    )
   )
  )
 )
)
]);
Set(OnReset, [If(
 Label([t-nodestroy], c) = 0,
 DestroyAtom
)
]);
Set(OnUser, [If(
 DoubleClick,
 {* Double Click *}
 If(
  SelectAtom(a, First, [Select an atom from the contents]),
  ExecOnUser(a)
 ),
 {* Right click *}
Do(
  { Delete any current instances of this form.} 
  GuiDestroy([Container]),

  { Register the GUI-form for this atom.}
  GuiRegister(PDir([\Atoms\Container.gui]), 1),

  { Show the GUI-form.}
   GuiCreate([Container], [Container], 0, c, 0, 1)
   )
)
]);
Set(On2DDraw, [if(
 c.DrawFlag,
 
 {--External atom(s) control container rotationas--}
 do(
  {--Variables for rotationas in order to compensate change of transportation direction--}
  RotateCoords(c.DrawRotationas, 0, 0, 1),
  
  {--Variables for translation in order to compensate change of transportation direction--}
  TranslateCoords(c.DrawXtranslate, c.DrawYtranslate, 0),
  
  {--Rotated shape--}
  dishape(0, 0, c.DrawXsize, c.DrawYsize, 0.01, ColorBlack, color(c))
 ),
 
 {--Standard--}
 do(
  c.DrawXsize := xSize(c),
  c.DrawYsize := ySize(c)
  {--Outline--}
 )
 
)
]);
Set(On3DDraw, [do(

 if(
  {--Container rotationas has been changed by external atom (e.g. Corner Transfer Unit)--}
  c.DrawFlag,
  do(
   {--Variables for rotationas in order to compensate change of transportation direction--}
   RotateCoords(c.DrawRotationas,0,0,1),
   
   {--Variables for translation in order to compensate change of transportation direction--}
   TranslateCoords(c.DrawXtranslate, c.DrawYtranslate,0)
  ),
  {--Standard--}
  do(
   c.DrawXsize := xSize(c),
   c.DrawYsize := ySize(c)
  )
 ),

 If(
  Or(
   BoxVisible(0, 0, 0, c.DrawXsize, c.DrawYsize ,zSize(c)),
   Not(UseBoxVisible)
  ),
  Case(
   ContainerType,
   {* Draw a Box *}
   Do(
    di3DBox(0, 0, 0, c.DrawXsize, c.DrawYsize, 0.01, Color(c)),
    di3DBox(0, 0, 0, c.DrawXsize, 0.01, zSize(c), Color(c)),
    di3DBox(0, c.DrawYsize, 0, c.DrawXsize, 0.01, zSize(c), Color(c)),
    di3DBox(0, 0, 0, 0.01, c.DrawYsize, zSize(c), Color(c)),
    di3DBox(c.DrawXsize, 0, 0, 0.01, c.DrawYsize, zSize(c), Color(c))
   ),
   {* Draw a Transparant box *}
   Do(
    di3DBox(-0.06, -0.06, 0, c.DrawXsize + 0.12, c.DrawYsize + 0.12, 0.1, ColorBlack),
    Plane(-0.04, -0.04, zSize(c), c.DrawYsize + 0.08, 0.15, 0, 90, 0, 90, ColorBlack),
    Plane(c.DrawXsize + 0.04, -0.04, zSize(c), c.DrawYsize + 0.08, 0.15, 0, 90, 0, 90, ColorBlack),
    Plane(-0.04, -0.04, zSize(c), c.DrawXsize + 0.08, 0.15, 0, 0, 0, 90, ColorBlack),
    Plane(-0.04, c.DrawYsize + 0.04, zSize(c), c.DrawXsize + 0.08, 0.15, 0, 0, 0, 90, ColorBlack),
    Glass(0.5), 
    Plane(-0.04, -0.04, 0.1, c.DrawYsize + 0.08, zSize(c) - 0.1, 0, 90, 0, 90, Color),
    Plane(c.DrawXsize + 0.04, -0.04, 0.1, c.DrawYsize + 0.08, zSize(c) - 0.1, 0, 90, 0, 90, Color),
    Plane(-0.04, -0.04, 0.1, c.DrawXsize + 0.08, zSize(c) - 0.1, 0, 0, 0, 90, Color),
    Plane(-0.04, c.DrawYsize + 0.04, 0.1, c.DrawXsize + 0.08, zSize(c) - 0.1, 0, 0, 0, 90, Color),
    Glass(1)
   ),
   {* Draw a Container *}
   Do(
    di3DBox(-0.05, -0.05, 0, c.DrawXsize + 0.1, c.DrawYsize + 0.1, 0.01, Color(c)),
    di3DBox(-0.05, -0.05, zSize(c), c.DrawXsize + 0.1, c.DrawYsize + 0.1, 0.01, Color(c)),
    di3DBox(-0.05, -0.05, 0, c.DrawXsize + 0.1, 0.01, zSize(c), Color(c)),
    di3DBox(-0.05, c.DrawYsize + 0.05, 0, c.DrawXsize + 0.1, -0.01, zSize(c), Color(c)),
    di3DBox(c.DrawXsize + 0.05, -0.04, 0, -0.01, c.DrawYsize + 0.08, zSize(c), Color(c))
   ),
   {* Draw a Pallet *}
   Do(
    di3DBox(0, 0, 0, c.DrawXsize, 0.1, zSize(c) - 0.05, Color),
    di3DBox(0, c.DrawYsize / 2 - 0.05, 0, c.DrawXsize, 0.1, zSize(c) - 0.05, Color),
    Di3DBox(0, c.DrawYsize - 0.1, 0, c.DrawXsize, 0.1, zSize(c) - 0.05, Color),
    c.CenterPoint := c.DrawXsize / 5,
    Repeat(
     5,
     di3DBox(Count * c.CenterPoint, 0, zSize(c) - 0.05, -0.1, c.DrawYsize, 0.05, Color)
    )
   ),
   {* Draw a Stabilized pallet *}
   Do( 
    di3DBox(0, 0, 0, c.DrawXsize, c.DrawYsize / 4 - 0.05, 0.05, 4823990),
    di3DBox(0, c.DrawYsize / 4, 0, c.DrawXsize, c.DrawYsize / 4 - 0.05, 0.05, 4823990),
    di3DBox(0, c.DrawYsize / 2, 0, c.DrawXsize,c.DrawYsize / 4 - 0.05, 0.05, 4823990),
    di3DBox(0, c.DrawYsize / 4 * 3, 0, c.DrawXsize, c.DrawYsize / 4, 0.05, 4823990), 
    di3DBox(-0.05, -0.05, 0, c.DrawXsize + 0.1, 0.05, 0.05, ColorGray),
    di3DBox(-0.05, -0.05, 0, 0.05, c.DrawYsize + 0.1, 0.05, ColorGray),
    di3DBox(c.DrawXsize, c.DrawYsize + 0.05, 0, 0.05, -0.1 - c.DrawYsize, 0.05, ColorGray),
    di3DBox(c.DrawXsize + 0.05, c.DrawYsize, 0,  -0.1 - c.DrawXsize, 0.05, 0.05, ColorGray),
    di3DBox(-0.05, -0.05, 0.05, 0.05, 0.05, zSize(c), ColorGray),
    di3DBox(-0.05, c.DrawYsize, 0.05, 0.05, 0.05, zSize(c), ColorGray),
    di3DBox(c.DrawXsize, c.DrawYsize, 0.05, 0.05, 0.05, zSize(c),ColorGray),
    di3DBox(c.DrawXsize, -0.05, 0.05, 0.05, 0.05, zSize(c), ColorGray)
   ),
   {* Draw a Textured Box (VR only) *}
   Do(
    DrawVRIcon(vrIcon, -0.05, -0.05, 0, c.DrawXsize + 0.1, c.DrawYsize + 0.1, 0.01, 0, 0, 0, Icon(c), Color(c)),
    DrawVRIcon(vrIcon, -0.05, -0.05, 0, c.DrawXsize + 0.1, 0.01, zSize(c), 0, 0, 0, Icon(c), Color(c)),
    DrawVRIcon(vrIcon, -0.05, c.DrawYsize + 0.04, 0, c.DrawXsize + 0.1, 0.01, zSize(c), 0, 0, 0, Icon(c), Color(c)),
    DrawVRIcon(vrIcon, -0.05, -0.04, 0, 0.01, c.DrawYsize + 0.08, zSize(c), 0, 0, 0, Icon(c), Color(c)),
    DrawVRIcon(vrIcon, c.DrawXsize + 0.04, -0.04, 0, 0.01, c.DrawYsize + 0.08, zSize(c), 0, 0, 0, Icon(c), Color(c))
   ),
   {** Pallet - Wood **}
   DrawModel3D(Model3D(1, c), 0, 0, 0, c.DrawXsize, c.DrawYsize, zSize(c)),
   {** Pallet - Plastic **}
   DrawModel3D(Model3D(2, c), 0, 0, 0, c.DrawXsize, c.DrawYsize, zSize(c)),
   {** Crate **}
   DrawModel3D(Model3D(3, c), 0, 0, 0, c.DrawXsize, c.DrawYsize, zSize(c))
  )
 )
 
)
]);
SetStatus(0);
int018;


{Atom: TrollyInventory}

sets;
AtomByName([Source], Main);
if(not(AtomExists), Error([Cannot find mother atom 'Source'. Inheriting from BaseClass.]));
CreateAtom(a, Up(s), [], 1, false);
int023([TrollyInventory], 7168771, 240);
Set(Icon(a), 
	RegisterIcon(pDir([Media\Images\atoms\source.bmp]), [source]));
AddModel3D(
	RegisterModel3D(Model3DDir([\source.wrl]), [source.wrl], 0, 0, 0, 1, 1, -1, -90, 0, 0), a);
AddModel3D(
	RegisterModel3D(Model3DDir([\source_Resized.wrl]), [Source_Resized.wrl], 0, 0, 0, 1, 1, -1, -90, 0, 0), a);
SetMaterial(
	RegisterMaterial([Default], 8421504, 8421504, 3289650, 0, 0.100000001490116, 0, false, false, 1, 0), 1, a);
Set(Version(a), 0);
SetTreeIcon(pDir([Media\Icons\Source.ico]));
SetChannels(1, 1);
SetChannelRanges(1, 1, 1, 255);
int001(124);
int013(1, 0, true, false, 0, 0, [], []);
SetLoc(2, 10, 0);
SetSize(6, 3, 2);
LockPosition(false);
LockSize(false);
DisableIconRotation(false);
SetProductCode([]);
SetExprAtt(1, [{.~1|~1~.}1]);
SetExprAtt(2, [0]);
SetExprAtt(3, [{.0|10. Do Nothing.}0]);
SetExprAtt(4, [0]);
SetExprAtt(5, [0]);
SetAtt(6, 70);
SetAtt(7, 4);
int024;
SetStatus(2);
int018;


{Atom: AvailableTrolleys}

sets;
AtomByName([Queue], Main);
if(not(AtomExists), Error([Cannot find mother atom 'Queue'. Inheriting from BaseClass.]));
CreateAtom(a, Up(s), [], 1, false);
int023([AvailableTrolleys], 12615680, 240);
Set(Icon(a), 
	RegisterIcon(IconsDir([bmp\atoms\queue.bmp]), [queue]));
SetMaterial(
	RegisterMaterial([Default], 8421504, 8421504, 3289650, 0, 0.100000001490116, 0, false, false, 1, 0), 1, a);
Set(Version(a), 0);
SetTreeIcon(pDir([Media\Icons\Queue.ico]));
SetChannels(2, 1);
SetChannelRanges(1, 255, 1, 255);
int001(125);
int013(1, 0, true, false, 0, 0, [], []);
int013(2, 0, true, true, 0, 0, [], []);
SetLoc(9, 10, 0);
SetSize(6, 3, 0);
LockPosition(false);
LockSize(false);
DisableIconRotation(false);
SetProductCode([]);
SetExprAtt(1, [{.~1|~1~.}1]);
SetAtt(2, 150);
SetExprAtt(3, [0]);
SetExprAtt(4, [0]);
SetExprAtt(5, [{.content(c)|Fifo (First In First Out).}content(c)]);
SetAtt(6, 1);
SetExprAtt(7, [{.openallic(c)|Any inputchannel.}openallic(c)]);
SetAtt(8, 2);
int024;
SetStatus(13);
int018;


{Atom: CustomerGrabsTrolley}

sets;
AtomByName([Assembler], Main);
if(not(AtomExists), Error([Cannot find mother atom 'Assembler'. Inheriting from BaseClass.]));
CreateAtom(a, Up(s), [], 1, false);
int023([CustomerGrabsTrolley], 4194432, 1264);
Set(Icon(a), 
	RegisterIcon(pDir([Media\Images\Machines\mach1001.bmp]), [mach1001], 1, 0, 0, 255, 255, false, 0));
AddModel3D(
	RegisterModel3D(Model3DDir([\assembler.wrl]), [assembler.wrl], 0, 0, 0, 1, 1, -1, -90, 0, 0), a);
SetMaterial(
	RegisterMaterial([Default], 8421504, 8421504, 3289650, 0, 0.100000001490116, 0, false, false, 1, 0), 1, a);
Set(Version(a), 0);
SetTreeIcon(pDir([Media\Icons\Assembler.ico]));
SetChannels(2, 1);
SetChannelRanges(2, 255, 1, 255);
int001(126);
int013(1, 0, true, false, 5, 0, [container/order/main product], []);
int013(2, 0, false, true, 0, 0, [], []);
SetLoc(17, 7, 0);
SetSize(7, 5, 1);
LockPosition(false);
LockSize(false);
DisableIconRotation(false);
SetProductCode([]);
SetExprAtt(1, [0]);
SetExprAtt(2, [0]);
SetExprAtt(3, [0]);
SetExprAtt(4, [{.~1|~1~.}1]);
SetAtt(5, 1);
SetExprAtt(6, [1]);
SetAtt(7, 2);
SetAtt(8, 1);
SetAtt(9, 1);
SetExprAtt(10, [0]);
SetAtt(11, 1);
SetAtt(12, 2);
int024;
SetTable(2, 1);
int015(0, 64, [ 
`Input ch1`
`Input ch2`
]);
int015(1, 64, [`Product 1`
1
1
]);
SetStatus(1);
int018;


{Atom: CustomerReturnsTrolley}

sets;
AtomByName([Unpack], Main);
if(not(AtomExists), Error([Cannot find mother atom 'Unpack'. Inheriting from BaseClass.]));
CreateAtom(a, Up(s), [], 1, false);
int023([CustomerReturnsTrolley], 4194432, 1264);
Set(Icon(a), 
	RegisterIcon(IconsDir([bmp\atoms\server.bmp]), [server]));
AddModel3D(
	RegisterModel3D(Model3DDir([\disassembler.wrl]), [disassembler.wrl], 0, 0, 0, 1, 1, -1, -90, 0, 0), a);
SetMaterial(
	RegisterMaterial([Default], 8421504, 8421504, 3289650, 0, 0.100000001490116, 0, false, false, 1, 0), 1, a);
Set(Version(a), 0);
SetTreeIcon(pDir([Media\Icons\Unpack.ico]));
SetChannels(1, 2);
SetChannelRanges(1, 255, 2, 2);
int001(127);
int013(1, 0, true, false, 0, 0, [Contents], []);
int013(2, 0, true, false, 0, 0, [], []);
SetLoc(51, 7, 0);
SetSize(8, 2, 1);
LockPosition(false);
LockSize(false);
DisableIconRotation(false);
SetProductCode([]);
SetExprAtt(1, [content(first(c))]);
SetExprAtt(2, [0]);
SetAtt(3, 0);
SetExprAtt(4, [0]);
SetExprAtt(5, [0]);
SetExprAtt(6, [0]);
SetExprAtt(7, [{.openallic(c)|1. Any inputchannel.}openallic(c)]);
SetAtt(8, 2);
int024;
SetStatus(21);
int018;


{Atom: Cash-Desk}

sets;
AtomByName([MultiService], Main);
if(not(AtomExists), Error([Cannot find mother atom 'MultiService'. Inheriting from BaseClass.]));
CreateAtom(a, Up(s), [], 1, false);
int023([Cash-Desk], 0, 232);
Set(Icon(a), 
	RegisterIcon(IconsDir([bmp\atoms\server.bmp]), [server]));
SetMaterial(
	RegisterMaterial([Default], 8421504, 8421504, 3289650, 0, 0.100000001490116, 0, false, false, 1, 0), 1, a);
Set(Version(a), 0);
SetTreeIcon(pDir([Media\Icons\MultiServer.ico]));
SetChannels(1, 1);
SetChannelRanges(1, 255, 1, 255);
int001(128);
int013(1, 0, true, false, 0, 0, [], []);
SetLoc(42, 7, 0);
SetSize(8, 5, 1);
LockPosition(false);
LockSize(false);
DisableIconRotation(false);
SetProductCode([]);
SetAtt(1, 1);
SetExprAtt(2, [Label([NumberOfProductsToBuy], i)*3+15]);
SetAtt(3, 0);
SetAtt(4, 0);
SetExprAtt(5, [{.~1|~1~.}1]);
SetExprAtt(6, [{.openallic(c)|Any inputchannel.}openallic(c)]);
SetExprAtt(7, [0]);
SetExprAtt(8, [0]);
SetAtt(9, 0);
SetAtt(10, 1);
SetAtt(11, 0);
int024;
SetStatus(1);
int018;


{Atom: Generic Monitor16}

sets;
AtomByName([Generic Monitor], Main);
if(not(AtomExists), Error([Cannot find mother atom 'Generic Monitor'. Inheriting from BaseClass.]));
CreateAtom(a, Up(s), [], 1, false);
int023([Generic Monitor16], 15793151, 1250);
Set(Icon(a), 
	RegisterIcon(pDir([Media\Images\atoms\graph.bmp]), [graph]));
SetMaterial(
	RegisterMaterial([Default], 8421504, 8421504, 3289650, 0, 0.100000001490116, 0, false, false, 1, 0), 1, a);
Set(Version(a), 0);
SetTreeIcon(pDir([Media\Icons\Monitor.ico]));
Set(DdbRec, [>lastrefreshmoment:51205.>newestrecord:247.>nwgrtyp:1.]);
SetChannels(1, 0);
SetChannelRanges(1, 10, 0, 0);
int001(129);
int013(1, 0, true, true, 0, 0, [], []);
SetLoc(7, 15, 0);
SetSize(77, 18.4285714285714, 0);
LockPosition(false);
LockSize(false);
DisableIconRotation(false);
SetProductCode([]);
SetTextAtt(1, [Open Cash-Desks]);
SetAtt(2, 20);
SetExprAtt(3, [5]);
SetAtt(4, 1);
SetAtt(5, 15);
SetAtt(6, 500);
SetExprAtt(7, [{.~1|~Att([Capacity], In(1,c))~.}Att([Capacity], In(1,c))]);
SetAtt(8, 0);
SetAtt(9, 0);
SetAtt(10, 0);
SetAtt(11, 0);
SetAtt(12, 0.125);
SetAtt(13, 0.025);
SetAtt(14, 0);
SetAtt(15, 16711680);
SetAtt(16, 0.857142857142857);
SetAtt(17, 20);
SetAtt(18, 0);
SetAtt(19, 1);
SetAtt(20, 1);
SetAtt(21, 0);
SetAtt(22, 0.428571428571429);
SetAtt(23, 5);
SetAtt(24, 8421504);
SetAtt(25, 1);
SetAtt(26, 1);
SetAtt(27, 16711680);
SetAtt(28, 0);
SetTextAtt(29, [Currently opened cash-desks]);
SetAtt(30, 0);
int024;
SetTable(500, 1);
int015(0, 0, [ 
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
97
98
99
100
101
102
103
104
105
106
107
108
109
110
111
112
113
114
115
116
117
118
119
120
121
122
123
124
125
126
127
128
129
130
131
132
133
134
135
136
137
138
139
140
141
142
143
144
145
146
147
148
149
150
151
152
153
154
155
156
157
158
159
160
161
162
163
164
165
166
167
168
169
170
171
172
173
174
175
176
177
178
179
180
181
182
183
184
185
186
187
188
189
190
191
192
193
194
195
196
197
198
199
200
201
202
203
204
205
206
207
208
209
210
211
212
213
214
215
216
217
218
219
220
221
222
223
224
225
226
227
228
229
230
231
232
233
234
235
236
237
238
239
240
241
242
243
244
245
246
247
248
249
250
251
252
253
254
255
256
257
258
259
260
261
262
263
264
265
266
267
268
269
270
271
272
273
274
275
276
277
278
279
280
281
282
283
284
285
286
287
288
289
290
291
292
293
294
295
296
297
298
299
300
301
302
303
304
305
306
307
308
309
310
311
312
313
314
315
316
317
318
319
320
321
322
323
324
325
326
327
328
329
330
331
332
333
334
335
336
337
338
339
340
341
342
343
344
345
346
347
348
349
350
351
352
353
354
355
356
357
358
359
360
361
362
363
364
365
366
367
368
369
370
371
372
373
374
375
376
377
378
379
380
381
382
383
384
385
386
387
388
389
390
391
392
393
394
395
396
397
398
399
400
401
402
403
404
405
406
407
408
409
410
411
412
413
414
415
416
417
418
419
420
421
422
423
424
425
426
427
428
429
430
431
432
433
434
435
436
437
438
439
440
441
442
443
444
445
446
447
448
449
450
451
452
453
454
455
456
457
458
459
460
461
462
463
464
465
466
467
468
469
470
471
472
473
474
475
476
477
478
479
480
481
482
483
484
485
486
487
488
489
490
491
492
493
494
495
496
497
498
499
500
]);
int015(1, 0, [1
]);
SetStatus(0);
int018;


{Atom: New Atom}

sets;
BaseClass;
CreateAtom(a, Up(s), [], 1, false);
int023([New Atom], 0, 1226);
Set(Icon(a), 
	RegisterIcon(pDir([media\images\default.jpg]), [default.jpg]));
SetMaterial(
	RegisterMaterial([Default], 8421504, 8421504, 3289650, 0, 0.100000001490116, 0, false, false, 1, 0), 1, a);
Set(Version(a), 0);
SetTreeIcon(0);
int001(130);
SetSize(1, 1, 1);
LockPosition(false);
LockSize(false);
DisableIconRotation(false);
SetProductCode([]);
int024;
SetStatus(0);
int018;


{Atom: DecisionControl}

sets;
AtomByName([New Atom], Main);
if(not(AtomExists), Error([Cannot find mother atom 'New Atom'. Inheriting from BaseClass.]));
CreateAtom(a, Up(s), [], 1, false);
int023([DecisionControl], 12632256, 1258);
Set(Icon(a), 
	RegisterIcon(pDir([media\images\default.jpg]), [default.jpg]));
SetMaterial(
	RegisterMaterial([Default], 8421504, 8421504, 3289650, 0, 0.100000001490116, 0, false, false, 1, 0), 1, a);
Set(Version(a), 0);
SetTreeIcon(ModDir([\slider.bmp]));
SetChannels(2, 0);
SetChannelRanges(2, 2, 0, 0);
int001(131);
int013(1, 0, true, true, 0, 0, [AtomToControl], []);
int013(2, 0, true, true, 0, 0, [], []);
SetLoc(37, 1, 0);
SetSize(8, 2, 1);
LockPosition(false);
LockSize(false);
DisableIconRotation(false);
SetProductCode([]);
CreateAttributes(7);
SetAttributeName(r(1), [Title]);
SetAttributeName(r(2), [valDecisionVariable]);
SetAttributeName(r(3), [decisionRule]);
SetAttributeName(r(4), [decisionStrategy]);
SetAttributeName(r(5), [smoothingPercentage]);
SetAttributeName(r(6), [maxCashDesks]);
SetAttributeName(r(7), [numTrolleys]);
SetTextAtt(r(1), [DecisionControl]);
SetAtt(r(2), 4);
SetAtt(r(3), 1);
SetTextAtt(r(4), [Exponential Smoothing]);
SetAtt(r(5), 65);
SetAtt(r(6), 10);
SetAtt(r(7), 70);
int024;
SetTable(9, 1);
int015(0, 64, [ 
1
2
3
4
5
6
7
8
9
]);
int015(1, 64, [1
10
18
24
30
35
39
42
45
47
]);
Set(OnEvent, [do(
  { * Retrieve the current content of the queue in front of the atom to control * }
  Var([queueSize], vbValue, Content(In(1, In(1, c)))),
  
  { * Check if an automatic rule should be applied * }
  if (Att([decisionRule], c) = 1,
    do ( 
      { * get the value of the decision variable* }
      Var([decisionVariable], vbValue, Att([valDecisionVariable], c)),
      
      { * Check if linear calculation is selected * }
      if (
        CompareText(Att([decisionStrategy], c), [Linear]),
        do ( { /if -> linear }
          Var([neededCashDesks], vbValue, 0),
          Var([iCounter], vbValue, 1),
          { * iterate through every number of cash-desks until either the maximum allowed cash-desk 
              are reached or one combination has been found which supports the current queue size* }
          for (iCounter := 1, And(iCounter < Att([maxCashDesks], c), neededCashDesks=0), Inc(iCounter),
            if (queueSize <= decisionVariable * iCounter,
              neededCashDesks := iCounter
            )
          ),
          if (neededCashDesks <> 0,
            Att([Capacity], In(1, c)) := neededCashDesks,
            Att([Capacity], In(1, c)) := Att([maxCashDesks], c)
          ),
          { * In case there is space for another customer, open the input * }
          CreateEvent(0, In(1, c), 2)
        ), { /end linear strategy }
        
        
        
        do ( { /else -> exponential smoothing }         
          Var([smoothingFactor], vbValue, Att([smoothingPercentage], c)/100),
          Var([neededCashDesks], vbValue, 0),
          Var([iCounter], vbValue, 1),
          Var([Sn], vbValue, decisionVariable),
          
          { * Determine the content of the queue, i.e. the number of waiting customers * }
          for (iCounter := 1, And(iCounter < Att([maxCashDesks], c), neededCashDesks=0), Inc(iCounter),
            do(
              Sn := smoothingFactor * decisionVariable * iCounter + (1 - smoothingFactor) * Sn,
              {Trace(Concat([S],String(iCounter),[: ],String(Sn))),}
              if (queueSize <= Sn,
                neededCashDesks := iCounter
              )
            )
          ),
          { * Change the capacity of the cash-desk, based on the number of waiting customers * }
          if (neededCashDesks <> 0,
            Att([Capacity], In(1, c)) := neededCashDesks,
            Att([Capacity], In(1, c)) := Att([maxCashDesks], c)
          ),          
    
          { * In case there is space for another customer, open the input * }
          CreateEvent(0, In(1, c), 2)
        ) { /end exponential smoothening }
      ) { /endif }
    ),
    
    
    
    if (Att([decisionRule], c) = 2, 
      { * User defined rule selected * }
      do ( { /else if -> user defined rule }
        Trace([Executing user defined rule!]),
        if ( nRows(c) > 0,
          do (
            Var([neededCashDesks], vbValue, 0),   
            Var([iCounter], vbValue, 1),      
            for (iCounter := 1, And(iCounter <= nRows(c), neededCashDesks = 0), Inc(iCounter),
              if (queueSize <= Cell(iCounter, 1, c, 1),
                neededCashDesks := iCounter
              )
            ),
            if (neededCashDesks <> 0,
              Att([Capacity], In(1, c)) := neededCashDesks,
              Att([Capacity], In(1, c)) := nRows+1
            )
          )
        ),
        { * In case there is space for another customer, open the input * }
        CreateEvent(0, In(1, c), 2)
      ),
      
      
      do( { /else  * Default behavior - non-adaptive Rule * }
        Att([Capacity], In(1, c)) := Att([maxCashDesks]),
        CreateEvent(0, In(1, c), 2)
      )
      
      
    )                
  ), { /endif }
  CreateEvent(5, c)
)
]);
Set(OnReset, [CreateEvent(5, c)
]);
Set(OnUser, [Do(
 { Delete any current instances of this form.} 
 GuiDestroy([frmDecisionControl]),

 { Register the GUI-form for this atom.}
 GuiRegister(ModDir([\DecisionControl.gui]), 1),

 { Show the GUI-form.}
 Guicreate([frmDecisionControl], [frmDecisionControl], 0, c, 0, 1)
)
]);
Set(On2DDraw, [do (
 Draw2DIcon(3, [DecisionControl], Name),
 if (Att([decisionRule], c) = 0,
  diText(0, ySize(c)+0.5, [Using non-adaptive rule], ColorBlack, ColorWhite, 0.5, [Arial]),
  if (Att([decisionRule], c) = 1,
   do(
    diText(0, ySize(c)+0.5, Concat([Queue size for new cash-desk: ], String(Att([valDecisionVariable], c))), ColorBlack, ColorWhite, 0.5, [Arial]),
    diText(0, ySize(c)+1.5, Concat([Strategy used: ], String(Att([decisionStrategy], c))), ColorBlack, ColorWhite, 0.5, [Arial]),
    if (CompareText(Att([decisionStrategy], c), [Exponential Smoothing]),
     diText(0, ySize(c)+2.5, Concat([Smoothing by: ], String(100 - Att([smoothingPercentage], c)), [%]), ColorBlack, ColorWhite, 0.5, [Arial])
    )
   ),
   diText(0, ySize(c)+0.5, [Using user-defined rule], ColorBlack, ColorWhite, 0.5, [Arial])
  )
 )
)
]);
SetStatus(0);
int018;
Up;
int014(1, 114, 1, 118, 0);
int014(2, 127, 1, 114, 0);
int014(1, 115, 1, 116, 0);
int014(0, 123, 1, 115, 0);
int014(1, 116, 1, 126, 0);
int014(2, 116, 1, 122, 0);
int014(1, 122, 1, 117, 0);
int014(1, 119, 1, 128, 0);
int014(1, 120, 1, 119, 0);
int014(1, 126, 1, 120, 0);
int014(1, 124, 1, 125, 0);
int014(0, 121, 1, 124, 0);
int014(1, 125, 2, 126, 0);
int014(1, 127, 2, 125, 0);
int014(1, 128, 1, 127, 0);
int014(0, 128, 1, 129, 0);
int014(0, 128, 1, 131, 0);
int014(0, 124, 2, 131, 0);
int006(3, 115, 1, 0, 0);
int006(0, 124, 1, 0, 0);
int006(0, 129, 0, 0, 0);
int006(5, 131, 0, 0, 0);


{Experiment settings}

int034;
int007;
